﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class EndGameScript : MonoBehaviour {
	
	public AudioClip button;
	public AudioClip end;
	public Text endText;
	string temp;
	
	IEnumerator TheEnd () {

		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			if (gameDataScript.gameMode == "p") {
				if (gameDataScript.loser == "Player1") {
					temp = "Player 2 wins";
				} else if (gameDataScript.loser == "Player2") {
					temp = "Player 1 wins";
				}
			} else {
				temp = "You survived " + gameDataScript.timed;
			}
			endText.text = temp;
		}
		yield return new WaitForSeconds (0.25f);
		audio.PlayOneShot (end);
		yield return new WaitForSeconds (end.length);
		
	}
	
	IEnumerator MainMenuAfterSound () {
		
		audio.PlayOneShot (button);
		yield return new WaitForSeconds (button.length);
		Application.LoadLevel ("MainMenu");
		
	}
	
	IEnumerator QuitAfterSound () {
		
		audio.PlayOneShot (button);
		yield return new WaitForSeconds (button.length);
		Application.Quit ();
		
	}
	
	//starts the corresponding coroutine when the button to which it is assigned is clicked
	public void MainMenu () {
		
		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			gameDataScript.gameMode = "";
			gameDataScript.loser = "";
			gameDataScript.timed = "";
		}
		
		StartCoroutine (MainMenuAfterSound ());
		
	}
	
	//starts the corresponding coroutine when the button to which it is assigned is clicked
	public void QuitGame () {
		
		StartCoroutine (QuitAfterSound ());
		
	}
	
	// Use this for initialization
	void Start () {
		
		StartCoroutine (TheEnd ());
		
	}
}
