﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class GameObjectScript : MonoBehaviour {
	
	public AudioClip beepS;
	public AudioClip beepL;
	public AudioClip button;
	public bool playing = false;
	public Camera player1Cam;
	public Camera splitCam;
	public GameObject player1;
	public GameObject robo1;
	public GameObject player2;
	public GameObject robo2;
	public Text begin;
	public Text brian;
	public Text countdown;
	public Text gameOver;
	public Text player1Text;
	public Text player2Text;
	public Text timerDisplay;
	public RawImage helpMenuC;
	public RawImage helpMenuP;
	public RawImage helpMenuS;
	public RawImage timerHolder;
	public string timerText = "";
	float timer = 0;
	FPSInputControllerS singleControl;
	FPSInputControllerC coOpControl;
	FPSInputControllerP1 p1Control;
	FPSInputControllerP2 p2Control;
	string mode = "";
	
	IEnumerator CountingDown () {
		
		yield return new WaitForSeconds (1);
		countdown.text = "3";
		audio.PlayOneShot (beepS);
		yield return new WaitForSeconds (beepS.length + 1);
		countdown.text = "2";
		audio.PlayOneShot (beepS);
		yield return new WaitForSeconds (beepS.length + 1);
		countdown.text = "1";
		audio.PlayOneShot (beepS);
		yield return new WaitForSeconds (beepS.length + 1);
		countdown.text = "";
		audio.PlayOneShot (beepL);
		yield return new WaitForSeconds (beepL.length);
		playing = true;
		Update ();
		
	}
	
	IEnumerator HideHelpCAfterSound () {
		
		audio.PlayOneShot (button);
		yield return new WaitForSeconds (button.length);
		begin.enabled = false;
		helpMenuC.enabled = false;
		timerText = "00:00";
		timerHolder.enabled = true;
		timerDisplay.text = timerText;
		CountdownClock ();
		
	}
	
	IEnumerator HideHelpPAfterSound () {
		
		audio.PlayOneShot (button);
		yield return new WaitForSeconds (button.length);
		begin.enabled = false;
		helpMenuP.enabled = false;
		splitCam.rect = new Rect (0.495f, 0, 0.01f, 1);
		splitCam.cullingMask = 0;
		AudioListener tempP = splitCam.GetComponent <AudioListener> ();
		tempP.enabled = true;
		AudioListener tempS = player1Cam.GetComponent <AudioListener> ();
		tempS.enabled = false;
		CountdownClock ();
		
	}
	
	IEnumerator HideHelpSAfterSound () {
		
		audio.PlayOneShot (button);
		yield return new WaitForSeconds (button.length);
		begin.enabled = false;
		helpMenuS.enabled = false;
		timerText = "00:00";
		timerHolder.enabled = true;
		timerDisplay.text = timerText;
		CountdownClock ();
		
	}

	// Use this for initialization
	void Start () {
		
		player1Text.enabled = false;
		player2Text.enabled = false;
		timerHolder.enabled = false;
		timerDisplay.text = timerText;
		countdown.text = "";
		gameOver.enabled = false;

		if (Application.loadedLevelName == "Level3") {
			brian.enabled = false;
		}
		
		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			if (gameDataScript.gameMode == "s") {
				helpMenuC.enabled = false;
				helpMenuP.enabled = false;
				helpMenuS.enabled = true;
				singleControl = player1.GetComponent<FPSInputControllerS>();
			} else if (gameDataScript.gameMode == "c") {
				helpMenuC.enabled = true;
				helpMenuP.enabled = false;
				helpMenuS.enabled = false;
				coOpControl = player1.GetComponent<FPSInputControllerC>();
			} else if (gameDataScript.gameMode == "p") {
				helpMenuC.enabled = false;
				helpMenuP.enabled = true;
				helpMenuS.enabled = false;
				p1Control = player1.GetComponent<FPSInputControllerP1>();
				p2Control = player2.GetComponent<FPSInputControllerP2>();
				player1Text.enabled = true;
				player2Text.enabled = true;
				player2.SetActive (true);
				player1Cam.rect = new Rect (0, 0, 0.495f, 1);
			}
			mode = gameDataScript.gameMode;
		}
	
	}
	
	// Update is called once per frame
	void Update () {
		if (playing == false) {
			robo1.SendMessage("EnableS",false);
			robo1.SendMessage("EnableC",false);
			robo1.SendMessage("EnableP1",false);
			if (mode == "s") {
				singleControl.enabled = false;
			} else if (mode == "c") {
				coOpControl.enabled = false;
			} else if (mode == "p") {
				p1Control.enabled = false;
				p2Control.enabled = false;
				robo2.SendMessage("EnableP2",false);
			}
		} else {
			if (mode == "s") {
				singleControl.enabled = true;
				robo1.SendMessage("EnableS",true);
				robo1.SendMessage("EnableC",false);
				robo1.SendMessage("EnableP1",false);
			} else if (mode == "c") {
				coOpControl.enabled = true;
				robo1.SendMessage("EnableS",false);
				robo1.SendMessage("EnableC",true);
				robo1.SendMessage("EnableP1",false);
			} else if (mode == "p") {
				p1Control.enabled = true;
				robo1.SendMessage("EnableS",false);
				robo1.SendMessage("EnableC",false);
				robo1.SendMessage("EnableP1",true);
				p2Control.enabled = true;
				robo2.SendMessage("EnableP2",true);
			}
		}
		
		if (helpMenuC.enabled == true) {
			if (Input.GetKeyDown (KeyCode.Space)) {
				StartCoroutine (HideHelpCAfterSound ());
			}
		} else if (helpMenuP.enabled == true) {
			if (Input.GetKeyDown (KeyCode.Space)) {
				StartCoroutine (HideHelpPAfterSound ());
			}
		} else if (helpMenuS.enabled == true) {
			if (Input.GetKeyDown (KeyCode.Space)) {
				StartCoroutine (HideHelpSAfterSound ());
			}
		}
		
		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			if (gameDataScript.gameMode != "p") {
				if (playing == true) {
					timer += Time.deltaTime;
					int minutes = Mathf.FloorToInt (timer / 60f);
					int seconds = Mathf.FloorToInt(timer - minutes*60);
					timerText = string.Format("{00:00}:{01:00}", minutes, seconds);
					timerDisplay.text = timerText;
				}
			}
		}
	
	}
	
	void CountdownClock () {
		
		StartCoroutine (CountingDown ());
		
	}

}
