﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class MainMenuScript : MonoBehaviour {

	public Slider volumeSlider;
	float volume;
	
	IEnumerator GameAfterSound () {
		
		audio.Play ();
		yield return new WaitForSeconds (audio.clip.length);
		Application.LoadLevel ("LevelSelect");
		
	}
	
	IEnumerator QuitAfterSound () {
		
		audio.Play ();
		yield return new WaitForSeconds (audio.clip.length);
		Application.Quit ();
		
	}
	
	//starts the corresponding coroutine when the button to which it is assigned is clicked
	public void LoadSinglePlayer () {

		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			gameDataScript.gameMode = "s";
		}

		StartCoroutine (GameAfterSound ());
		
	}
	
	//starts the corresponding coroutine when the button to which it is assigned is clicked
	public void LoadCoOp () {
		
		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			gameDataScript.gameMode = "c";
		}
		
		StartCoroutine (GameAfterSound ());
		
	}
	
	//starts the corresponding coroutine when the button to which it is assigned is clicked
	public void LoadPvP () {
		
		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			gameDataScript.gameMode = "p";
		}
		
		StartCoroutine (GameAfterSound ());
		
	}
	
	//starts the corresponding coroutine when the button to which it is assigned is clicked
	public void QuitGame () {
		
		StartCoroutine (QuitAfterSound ());
		
	}

	// Use this for initialization
	void Start () {

		GameObject gameData = GameObject.Find ("GameData");

		if (gameData == null) {
			
			gameData = new GameObject ("GameData");
			gameData.AddComponent <GameDataScript> ();
			AudioSource music = gameData.AddComponent <AudioSource> ();
			music.clip = Resources.Load ("Sound/LastDays") as AudioClip;
			music.loop = true;
			music.Play ();
			volume = 0.5f;

		} else {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			volume = gameDataScript.masterVolume;
			volumeSlider.value = volume;
			
		}
	
	}
	
	// Update is called once per frame
	void Update () {

		//determines if persistent data exists, and the player's name, and the master volume are assigned from it to the private variables
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			gameDataScript.masterVolume = volume;
			
		}
		volume = volumeSlider.value;
	
	}
}
