﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class PanCameraScript : MonoBehaviour {

	public bool panning;
	public float newY;
	public GameObject world;
	public Material colourW;
	public Material colourT;
	public RawImage timerI;
	public string nextLevel;
	public Text brian;
	public Text gameOver;
	public Text player1;
	public Text player2;
	public Text timerT;
	string level = "";

	IEnumerator NowEnd () {

		yield return new WaitForSeconds (1);
		Application.LoadLevel (nextLevel);

	}

	// Use this for initialization
	void Start () {
		
		level = Application.loadedLevelName;
		if (level == "Level3") {
			gameOver.enabled = false;
			player1.enabled = false;
			player2.enabled = false;
			timerI.enabled = false;
			timerT.enabled = false;
			world.renderer.material = colourW;
			RenderSettings.fog = false;
			//find all objects tagged 'environment'
			GameObject[] toDeleteE = GameObject.FindGameObjectsWithTag("environment");
			//delete them
			foreach (GameObject delObject in toDeleteE) {
				GameObject.Destroy (delObject);
			}
			GameObject[] toDeleteP = GameObject.FindGameObjectsWithTag("Player");
			//delete them
			foreach (GameObject delObject in toDeleteP) {
				GameObject.Destroy (delObject);
			}
		}
		panning = true;

	}

	// Update is called once per frame
	void Update () {

		if (panning == true) {
			Vector3 newPos = transform.localPosition;
			newPos.y = Mathf.Lerp (transform.localPosition.y, newY + 4, Time.deltaTime * 0.25f);
			transform.localPosition = newPos;
		} else {
			StartCoroutine (NowEnd ());
		}

		if (level != "Level3") {
			if (Input.GetKey (KeyCode.Space)) {
				panning = false;
			}
		} else {
			if (transform.localPosition.y >= 450) {
				//find all objects tagged 'tile'
				GameObject[] toDeleteT = GameObject.FindGameObjectsWithTag("tile");
				//delete them
				foreach (GameObject delObject in toDeleteT) {
					FloorTileScript floorTileScript = delObject.GetComponent<FloorTileScript> ();
					floorTileScript.working = false;
					delObject.renderer.material = colourT;
				}
			}
			if (transform.localPosition.y >= 457.5) {
				brian.enabled = true;
			}
		}

		if (transform.localPosition.y >= newY) {
			panning = false;
		}

	}

}
