﻿using UnityEngine;
using System.Collections;

public class PlayerPositionScript : MonoBehaviour {
	
	public AudioClip argh;
	public float posY;
	public GameObject panCam;
	public GameObjectScript gameObjectScript;
	bool dead = false;
	bool start = true;
	
	IEnumerator Dead () {
		
		//determines if persistent data exists
		GameObject gameData = GameObject.Find ("GameData");
		
		if (gameData != null) {
			
			GameDataScript gameDataScript = gameData.GetComponent <GameDataScript> ();
			if (gameDataScript.gameMode == "p") {
				if (dead == true && gameDataScript.loser == "") {
					gameDataScript.loser = gameObject.name;
					Debug.Log("Loser is " + gameDataScript.loser);
				}
			} else {
				gameDataScript.timed = gameObjectScript.timerText;
			}
		}
		
		gameObjectScript.gameOver.enabled = true;
		audio.PlayOneShot (argh);
		yield return new WaitForSeconds (argh.length + 0.5f);

		if (Application.loadedLevelName == "Level3") {
			panCam.SetActive (true);
		} else {
			Application.LoadLevel ("EndGame"); //...and then they die
		}
		
	}

	// Use this for initialization
	void Start () {
		
		if (gameObjectScript.playing == false) {
			float posX = transform.position.x;
			float posZ = transform.position.z;
			transform.position = new Vector3 (posX, posY, posZ);
		}
	
	}
	
	// Update is called once per frame
	void Update () {

		if (gameObjectScript.playing == false) {
			if (start == true) {
				float posX = transform.position.x;
				float posZ = transform.position.z;
				transform.position = new Vector3 (posX, posY, posZ);
			}
		} else {
			start = false;
		}

		if (transform.position.y < -3f) { //if the player falls past this point...
			gameObjectScript.playing = false;
			dead = true;
			StartCoroutine (Dead ()); //...it begins the death coroutine...
		}
	
	}

}
